/*
 *	File: mcu_dma.c
 *	Date: 15.03.2011
 *	Denis Zheleznjakov @ ZiBlog.ru
 */

#include "main.h"

const uint8_t dma_buffer[] = { 10, 20, 30, 40, 50, 60 };

//------------------------------------------------------------------------------
void mcu_dma_channel5_init(void)
{
	// разрешаем тактирование ДМА1
	if ((RCC->AHBENR & RCC_AHBENR_DMA1EN) != RCC_AHBENR_DMA1EN)
	{
		RCC->AHBENR |= RCC_AHBENR_DMA1EN;
	}

	// зазадем адрес приемника данных
	DMA1_Channel5->CPAR = (uint32_t) & TIM15->CCR1;
	// задаем адрес источника данных
	DMA1_Channel5->CMAR = (uint32_t) & dma_buffer[0];
	// указываем число пересылаемых данных
	DMA1_Channel5->CNDTR = ARRAY_LENGHT(dma_buffer);
	// разрешаем работу + режим
	DMA1_Channel5->CCR = DMA_CCR1_MINC | DMA_CCR1_CIRC | DMA_CCR1_DIR
			| DMA_CCR1_EN | DMA_CCR1_PSIZE_0;
}
